<?php
/*
 * This script was written by Uve M. Steinmann for Cyclonic Consulting
 * http://cyclonicconsulting.com for a particular WordPress project. 
 * 
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * You are given the permission to freely modify it and/or redistribute it,
 * but not to sell it.
 * 
 * If you would like it modified for your particular use, please contact me
 * at 804.230.3456.
 */

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
////         !!!!   BACKUP EVERYTHING BEFORE RUNNING THIS SCRIPT    !!!!          ////
//// THIS SCRIPT BACKUPS UP NOTHING AND DESTROYS CERTAIN PIECE OF DATA AS IT      ////
//// RUNS. THE AUTHOR WILL NOT BE HELD LIABLE FOR ANY DAMAGES BECAUSE THE SCRIPT  ////
//// IS PROVIDED AS IS AND WITHOUT GUARANTEE OF ANY KIND. IN OTHER WORDS, USE AT  ////
//// YOUR OWN RISK. AGAIN, MAKE SURE YOU HAVE A COMPLETE COPY OF YOUR DATABASE    ////
//// BEFORE YOU RUN THE SCRIPT.                                                   ////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////

/* 
 * We placed all our members from the old system into a table titled new_membership_list
 * and then upload that table into the WordPress MySQL database. Once the table was uploaded,
 * we ran this script against it to move the membership information into the correct WordPress
 * tables. As the script runs, it deletes the members that are moved into the Wordpress tables
 * from the new_membership_list table so that there is less risk of duplicate entries should the 
 * script time out or something else fail.
 * 
 * Place this script in the server directory and call it with the browser.
 * 
 * When the script is running your screen will stay the same or be blank (for a long time) 
 * and will only show the numbers of members were moved once the script is finished running.
 * 
 * The new_membership_list table was created with the following MySQL query...
 * 
CREATE TABLE IF NOT EXISTS `new_membership_list` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `OldOrgId` int(10) unsigned NOT NULL,
  `FullName` varchar(255) NOT NULL,
  `Address1` varchar(255) NOT NULL,
  `Address2` varchar(255) default NULL,
  `City` varchar(127) NOT NULL,
  `State` varchar(2) NOT NULL,
  `Zip` varchar(12) NOT NULL,
  `Country` varchar(63) default NULL,
  `Phone` varchar(12) default NULL,
  `Email` varchar(255) default NULL,
  `LoginId` varchar(63) NOT NULL,
  `Password` varchar(63) NOT NULL,
  `Type` varchar(15) NOT NULL,
  `RenewDate` date NOT NULL,
  PRIMARY KEY  (`ID`)
)
 * ID was a new unique value and OldOrgId was an old unique value
 * Fullname was a value like - ie, John & Sarah Smith
 * LoginId was always the last name - ie, Smith
 */

 
// Login information
// $host = the server the script is running on
$host = "";
// $user = MySQL database user name
$user = "";
// $pass = MySQL database user password
$pass = "";
$baseLink = mysql_connect($host, $user, $pass) or die("Could not connect to server.");
// $dbase = the database you are going to be working in
$dbase = "";
mysql_select_db($dbase, $baseLink);

// With a 2.0 GHz processor on a localhost machine, this script loops through approximately 40-42 memberships per second
// Script run time in seconds - set plenty high
set_time_limit(600);

// Put a column into wp_users for data integrity. We will delete this column at the end of the script.
$query0 = <<<Q0
alter table wp_users add column oldorgid int(10)
Q0;
mysql_query($query0, $baseLink) or die(mysql_error());

// Use to know how many memberships were moved in the 
$loop = 0;

// Return only the memberships that have email addresses from the new_membership_list
/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Removing the exclamation mark (!) in $query1 will pull the memberships that do not have email 
// addresses. Since WordPress requires email addresses, check to make sure this will not break the system.

$query1 = <<<Q1
select * from new_membership_list where email != ''
Q1;
$result1 = mysql_query($query1, $baseLink) or die(mysql_error());

// Loop through the returned membership values
while ($row1 = mysql_fetch_assoc($result1)) {
    $rowid = $row1['ID'];
    $oldorgid = $row1["OldOrgId"];
    // The fullname
    $fullname = addslashes($row1["FullName"]);
    $address1 = addslashes($row1["Address1"]);
    $address2 = addslashes($row1["Address2"]);
    $city = addslashes($row1["City"]);
    $state = addslashes($row1["State"]);
    $zip = addslashes($row1["Zip"]);
    $country = addslashes($row1["Country"]);
    $phone = addslashes($row1["Phone"]);
    $email = addslashes($row1["Email"]);
    // Login id was the same as the last name of the person
    $loginid = addslashes($row1["LoginId"]);
    $password = addslashes($row1["Password"]);
    // The old membership type
    $type = addslashes($row1["Type"]);
    $renewdate = $row1["RenewDate"];

    // Prepare data for wp_user table in WordPress
    // Prepare nicename by dropping all to lowercase
    // $nicename probably needs further help to make it fully WordPress compatible
    $nicename = strtolower($loginid);

    // Insert member into wp_user
    $query2 = <<<Q2
insert into wp_users set user_login='$loginid', user_pass='$password',
user_nicename='$nicename', display_name='$fullname', oldorgid='$oldorgid'
Q2;
    mysql_query($query2, $baseLink) or die(mysql_error());

    // Get the new WordPress id
    $query3 = <<<Q3
select id from wp_users where oldorgid='$oldorgid'
Q3;
    $result3 = mysql_query($query3, $baseLink) or die(mysql_error());

    while ($row3 = mysql_fetch_assoc($result3)) {
        $userid = $row3['id'];
    }

    // Prepare data for wp_usermeta
    ///////////////////////////////////
    // Get the strings total length
    $fullnamelength = strlen($fullname);
    $address1length = strlen($address1);
    $address2length = strlen($address2);
    $citylength = strlen($city);
    $statelength = strlen($state);
    $ziplength = strlen($zip);
    $countrylength = strlen($country);
    $phonelength = strlen($phone);
    $emaillength = strlen($email);

    // Prepare shipping and billing information
    // The 's:' is followed by the number of characters in the string for the given value that then follows
    // by the actual string value
    $meta = <<<M1
a:9:{s:5:"email";s:$emaillength:"$email";s:4:"name";s:$fullnamelength:"$fullname";s:8:"address1";s:$address1length:"$address1";s:8:"address2";s:$address2length:"$address2";s:4:"city";s:$citylength:"$city";s:5:"state";s:$statelength:"$state";s:3:"zip";s:$ziplength:"$zip";s:7:"country";s:2:"US";s:5:"phone";s:$phonelength:"$phone";}
M1;
    $preparedmeta = addslashes(stripslashes($meta));

    // first_name is going to be the fullname with the loginid (lastname) removed
    // Get the position of the first character of the last loginid (lastname)
    $position = strrpos($fullname, $loginid);
    // Get the first name(s)
    $firstname = trim(substr($fullname, 0, -($fullnamelength - $position)));

    $query4 = <<<Q4
insert into wp_usermeta set user_id='$userid', meta_key='first_name', meta_value='$firstname'
Q4;
    $query5 = <<<Q5
insert into wp_usermeta set user_id='$userid', meta_key='last_name', meta_value='$loginid'
Q5;
    $query6 = <<<Q6
insert into wp_usermeta set user_id='$userid', meta_key='nickname', meta_value='$fullname'
Q6;
    // This value may be able to be dropped since it is always blank.
    $query7 = <<<Q7
insert into wp_usermeta set user_id='$userid', meta_key='description', meta_value=''
Q7;
    $query8 = <<<Q8
insert into wp_usermeta set user_id='$userid', meta_key='rich_editing', meta_value='true'
Q8;
    $query9 = <<<Q9
insert into wp_usermeta set user_id='$userid', meta_key='comment_shortcuts', meta_value='false'
Q9;
    $query10 = <<<Q10
insert into wp_usermeta set user_id='$userid', meta_key='admin_color', meta_value='fresh'
Q10;
    $query11 = <<<Q11
insert into wp_usermeta set user_id='$userid', meta_key='use_ssl', meta_value='0'
Q11;
    $query12 = <<<Q12
insert into wp_usermeta set user_id='$userid', meta_key='show_admin_bar_font', meta_value='true'
Q12;
    $query13 = <<<Q13
insert into wp_usermeta set user_id='$userid', meta_key='show_admin_bar_admin', meta_value='false'
Q13;
    // This value may be able to be dropped since it is always blank.
    $query14 = <<<Q14
insert into wp_usermeta set user_id='$userid', meta_key='aim', meta_value=''
Q14;
    // This value may be able to be dropped since it is always blank.
    $query15 = <<<Q15
insert into wp_usermeta set user_id='$userid', meta_key='yim', meta_value=''
Q15;
    // This value may be able to be dropped since it is always blank.
    $query16 = <<<Q16
insert into wp_usermeta set user_id='$userid', meta_key='jabber', meta_value=''
Q16;
    // We are presuming all moved members are subscribers only
    $query17 = <<<Q17
insert into wp_usermeta set user_id='$userid', meta_key='wp_capabilities', meta_value='a:1:{s:10:"subscriber";s:1:"1";}'
Q17;
    $query18 = <<<Q18
insert into wp_usermeta set user_id='$userid', meta_key='wp_user_level', meta_value='0'
Q18;
    $query19 = <<<Q19
insert into wp_usermeta set user_id='$userid', meta_key='mp_shipping_info', meta_value='$preparedmeta'
Q19;
    $query20 = <<<Q20
insert into wp_usermeta set user_id='$userid', meta_key='mp_billing_info', meta_value='$preparedmeta'
Q20;

    // Insert member information into wp_usermeta by looping through the above queries
    $queryloop = 4;
    while ($queryloop <= 20) {
        $queryx = 'query' . $queryloop;
        // print $$queryx.'<hr/>'; // For troubleshooting purposes
        mysql_query($$queryx, $baseLink) or die(mysql_error());
        $queryloop++;
    }

    // Prepare data for wp_m_membership_relationships and update wp_m_membership_levels
    //////////////////////////////////////////////////////////////////////////////////
    // wp_m_membership_levels shows how many of each type of membership one has (best I can tell)
    /////////////////////////////////////////////////////////////////////////////////
    // wp_m_membership_relationships shows members subscribe level and expiration date
    /////////////////////////////////////////////////////////////////////////////////
    // This switch block is job specific and will need modification for each job
    
    
    switch ($type) {
        case 'BASC' :
            // $subid is found in wp_m_subscriptions_levels in field sub_id
            $subid = 1;
            // $levelid is found in wp_m_subscriptions_levels in field level_id
            $levelid = 1;
            break;
        case 'SUS' :
            $subid = 2;
            $levelid = 1;
            break;
        case 'LIFE' :
            $subid = 3;
            $levelid = 2;
            // An arbitary value for individual with a lifetime subscription since they did not have one earlier
            $renewdate = '2100-12-31';
            break;
    }

    // Update wp_m_membership_levels
    $query21 = <<<Q21
update wp_m_membership_levels set level_count=level_count+1 where id='$levelid'
Q21;
    mysql_query($query21, $baseLink) or die(mysql_error());

    // Update wp_m_membership_relationships
    $query22 = <<<Q22
insert into wp_m_membership_relationships set user_id='$userid', sub_id='$subid', level_id='$levelid', expirydate='$renewdate'
Q22;
    mysql_query($query22, $baseLink) or die(mysql_error());

    // Delete the row in the new_membership_list table so that the value is not entered twice
    $query23 = <<<Q23
delete from new_membership_list where id='$rowid'
Q23;
    mysql_query($query23, $baseLink) or die(mysql_error());
    $loop++;
}

// This column was put in at the beginning of the script for data integrity. Delete since it is no longer needed.
$query24 = <<<Q24
alter table wp_users drop column oldorgid
Q24;
mysql_query($query24, $baseLink) or die(mysql_error());

// Print the number of memberships that were moved on the screen once the script is finished running.
print $loop;
?>